
#property copyright " 2008-2011 BJF Trading Group"
#property link      "www.iticsoftware.com"

#define vers   "1.0"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Silver
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1


extern int  period = 70;
extern int  ma_period = 5;
extern int  ma_method = MODE_SMA;  

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double HurstBuf[];
double HurstMABuf[];

string short_name;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  IndicatorBuffers(2);
    
  SetIndexStyle(0, DRAW_LINE);
  SetIndexBuffer(0, HurstMABuf);
  SetIndexDrawBegin(0, period + ma_period);
  SetIndexLabel(0, "Hurst");
  
  SetIndexStyle(1, DRAW_NONE);
  SetIndexBuffer(1, HurstBuf);

  short_name = "Hurst("+period+")";
  IndicatorShortName(short_name);

  IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 1);

  SetLevelValue(0, 0.5);
}

void deinit()
{
}

void start() 
{  
  int counted_bars = IndicatorCounted();
  if(counted_bars < 0) return;
  if(counted_bars > 0) counted_bars--;

  int limit = Bars-counted_bars;

  double sum;
  double Average;
  double MaxC, MinC, R;
  double Hurst_a = 0.3;
  
  for(int i=limit;i>=0;i--)
  {
    MaxC=Close[iHighest(NULL,0,MODE_CLOSE,period,i)];
    MinC=Close[iLowest(NULL,0,MODE_CLOSE,period,i)];   
    R=MaxC-MinC;
    
    Average=iMA(NULL,0,period,0,0,0,i);
    
    sum=0;
    for (int j=1;j<=period;j++)
       sum+=MathPow((Average-Close[j+i]),2);
       
    double S=MathSqrt(sum/(period-1));
    
    if (S>0)
      HurstBuf[i]=(MathLog(R/S))/(MathLog(period*Hurst_a));           
  }
  
  for(i=limit;i>=0;i--)
  {
    HurstMABuf[i] = iMAOnArray(HurstBuf, Bars, ma_period, 0, ma_method, i);  
  }
}

